<template>
  <v-app
    id="inspire"
  >
    <v-main>
      <!-- <v-img src="
      @
      assets
      register.jpg"
    /> -->
      <v-container
        class="fill-height"
        fluid
        :style="style"
      >
        <v-row
          align="center"
          justify="center"
        >
          <v-col
            cols="12"
            sm="8"
            md="8"
          >
            <v-card class="elevation-5">
              <v-window v-model="step">
                <v-window-item :value="1">
                  <v-row class="fill-height">
                    <v-col
                      cols="12"
                      md="8"
                    >
                      <v-card-text class="mt-12">
                        <h1
                          class="text-center text-h3 cyan--text text--darken-3"
                        >
                          Sign in to loan
                        </h1>

                        <h4 class="text-center mt-4">
                          Ensure your email for registration
                        </h4>
                        <v-col
                          class="mx-auto"
                          md="8"
                        >
                          <v-form>
                            <v-text-field
                              v-model="username"

                              label="username"
                              name="username"
                              type="text"
                              color="cyan darken-3"
                              prepend-icon="mdi-account"
                            />

                            <v-text-field
                              v-model="password"
                              label="Password"
                              name="password"
                              prepend-icon="mdi-lock"
                              type="password"
                              :color="mainColor"
                            />
                          </v-form>
                        </v-col>

                        <div class="text-center mt-3">
                          <v-btn
                            rounded
                            :color="mainColor"
                            dark
                            @click="signIn"
                          >
                            SIGN IN
                          </v-btn>
                        </div>
                      </v-card-text>
                      <v-alert
                        v-show="showError"
                        dense
                        outlined
                        type="error"
                      >
                        wrong userName or password!
                      </v-alert>
                    </v-col>
                    <v-col
                      cols="12"
                      md="4"
                      class="cyan darken-3"
                    >
                      <v-card-text class="white--text mt-12">
                        <h1 class="text-center text-h3">
                          New friend?
                        </h1>
                        <h5
                          class="text-center"
                        />
                      </v-card-text>
                      <div class="text-center">
                        <v-btn
                          rounded
                          outlined
                          dark
                          @click="step++"
                        >
                          SIGN UP
                        </v-btn>
                      </div>
                    </v-col>
                  </v-row>
                </v-window-item>
                <v-window-item :value="2">
                  <v-row class="fill-height">
                    <v-col
                      cols="12"
                      md="4"
                      :class="mainColor"
                    >
                      <v-card-text class="white--text mt-12">
                        <h1 class="text-center text-h2">
                          Welcome Back!
                        </h1>
                        <h5
                          class="text-center text-h4"
                        >
                          Click here to log in
                        </h5>
                      </v-card-text>
                      <div class="text-center">
                        <v-btn
                          rounded
                          outlined
                          dark
                          @click="step--"
                        >
                          Sign in
                        </v-btn>
                      </div>
                    </v-col>

                    <v-col
                      cols="12"
                      md="8"
                    >
                      <v-card-text class="mt-12">
                        <h1 class="text-center text-h3 cyan--text cyan--accent-3">
                          Create Account
                        </h1>

                        <h4 class="text-center mt-4">
                          Ensure your email for registration
                        </h4>
                        <v-form>
                          <v-text-field
                            v-model="username"
                            label="Email"
                            name="Email"
                            prepend-icon="mdi-email"
                            color="cyan accent-3"
                          />

                          <v-text-field
                            id="password"
                            v-model="password"
                            label="Password"
                            name="password"
                            prepend-icon="mdi-lock"
                            type="password"
                            color="cyan accent-3"
                          />

                          <v-text-field
                            id="userCode"
                            v-model="userCode"
                            label="userCode"
                            name="userCode"
                            prepend-icon="mdi-lock"
                            type="userCode"
                            color="cyan accent-3"
                          />

                          <v-checkbox
                            v-model="userType"
                            :label="userLabel1"
                          />
                          <v-checkbox
                            v-model="userType2"
                            :label="userLabel2"
                          />
                        </v-form>
                      </v-card-text>
                      <div class="text-center mt-n5 mx-auto">
                        <v-btn
                          rounded
                          :color="mainColor"
                          dark
                          @click="signUp"
                        >
                          SIGN UP
                        </v-btn>
                        <v-alert
                          v-show="showAlert"
                          dense
                          type="success"
                        >
                          registered successfully
                        </v-alert>

                        <v-alert
                          v-show="showError"
                          dense
                          type="error"
                        >
                          register error!!!
                        </v-alert>
                      </div>
                    </v-col>
                  </v-row>
                </v-window-item>
              </v-window>
            </v-card>
          </v-col>
        </v-row>
      </v-container>
    </v-main>
  </v-app>
</template>

<script>

  import backgroundImg from '@/assets/login.jpg'
  import { getLogin, getRegister } from '@/request/api.js'
  import { get } from 'vuex-pathify'
  import { setToken } from '@/util/cookie'

  export default {
    name: 'Loginview',
    props: {
      source: String,
    },
    data: () => ({
      step: 1,
      mainColor: 'cyan darken-3',
      height: '400',
      style: {
        backgroundImage: `url(${backgroundImg})`,
      },
      password: '1293120947',
      username: 'hsy',
      userCode: '000001',
      userType: 1, // 默认userType是1
      USERTYPE: 1,
      userType2: 0,
      userLabel1: 'register from company',
      userLabel2: 'register from finance',
      showError: 0,
      showAlert: 0,
    }),
    watch: {
      userType: function () {
        this.userType2 = !this.userType
      },
      userType2: function () {
        this.userType = !this.userType2
      },
    },

    methods: {
      signIn: function (event) {
        // 跨域问题需要解决
        console.log(1)
        getLogin({
          password: this.password,
          userName: this.username,
        }).then(
          resolve => {
            console.log(resolve)
            this.USERTYPE = resolve.userType
            const token = 'falseToken'
            setToken(token)
            localStorage.setItem('UserType', this.USERTYPE)
            localStorage.setItem('UserName', this.username)
            if (this.USERTYPE !== -1) {
              this.$router.push({ path: '/mainpage' })
            } else {
              this.showError = 1
              setTimeout(() => {
                this.showError = 0
              }, 2000)
            }
          })
          .catch(err => {
            console.log(err)
            console.log('cannot get response')
            this.showError = 1
            setTimeout(() => {
              this.showError = 0
            }, 2000)
          })

        // this.$router.push({ path: '/mainpage/' })
      },

      signUp: function (event) {
        const type = this.userType === 1 ? 1 : 2
        // console.log(type)
        getRegister({
          userName: this.username,
          password: this.password,
          userType: type,
          userCode: this.userCode,
        }).then(resolve => {
          console.log(resolve)
          const status = resolve.status
          if (status === '404') {
            this.showError = 1
            setTimeout(() => {
              this.showError = 0
              this.step--
            }, 2000)
          } else if (status === '200') {
            this.showAlert = 1
            setTimeout(() => {
              this.showAlert = 0
              this.step--
            }, 2000)
          }
        },
        )
          .catch(err => {
            console.log(err)
          },
          )
      },
    },
  }
</script>

<style scoped>

</style>
